#include "compiler.h"

#ifndef HAVE_STRNDUP

char *my_strndup(const char *str, size_t n)
{
    size_t len = strnlen(str, n);
    char *buf = malloc(len+1);
    if (!buf)
	return NULL;
    memcpy(buf, str, len);
    buf[len] = 0;
    return buf;
}

#endif /* HAVE_STRNDUP */
