#include "compiler.h"
#include "strdupx.h"

#include <limits.h>

char *strndupx(const char *str, size_t n, size_t extra)
{
    size_t len = strnlen(str, n);
    char *buf = malloc(len + ++extra);

    if (!buf)
	return NULL;

    memcpy(buf, str, len);
    memset(buf+len, 0, extra+1);

    return buf;
}

char *strdupx(const char *str, size_t extra)
{
    return strndupx(str, SIZE_MAX, extra);
}
